function OGProgressBar(canvasId) {

	this.canvasId = canvasId;

	this.indeterminate = true;
	this.value = 0;
	this.phase = 0;
	this.registeredForAnimation = false;
	
	this.isIndeterminate = isIndeterminate;
	this.setIndeterminate = setIndeterminate;
	this.getValue = getValue;
	this.setValue = setValue;
	
	this.indeterminateFillImage = new Image();
	this.indeterminateFillImage.src = 'indeterminateProgressFill.png';

	this.fillImage = new Image();
	this.fillImage.src = 'progressFill.png';

	this.completedFillImage = new Image();
	this.completedFillImage.src = 'progressCompletedFill.png';

	this.backgroundFillImage = new Image();
	this.backgroundFillImage.src = 'progressBackgroundFill.png';

	this.draw = draw;	
	
	function isIndeterminate() {
		return this.indeterminate;
	}
	
	function setIndeterminate(flag) {
		if (this.indeterminate != flag) {
			this.indeterminate = flag;
			this.draw();
		}
	}
	
	function getValue() {
		return this.value;
	}
	
	function setValue(value) {
		if (value >= 1.0) {
			OGUnregisterForProgressBarAnimation(this);
			this.registeredForAnimation = false;
		} else if (! this.registeredForAnimation) {
			OGRegisterForProgressBarAnimation(this);
			this.registeredForAnimation = true;
		}
		this.value = parseFloat(value);
		this.draw();
	}
	
	function draw() {
		var canvas = document.getElementById(this.canvasId);

		if (canvas != null && canvas.getContext != null) {
			var height = parseInt(canvas.height);
			var width = parseInt(canvas.width);
			var ctx = canvas.getContext("2d");
			var fillImage = this.indeterminateFillImage;			

			if (! this.indeterminate && this.backgroundFillImage) {
				ctx.fillStyle = ctx.createPattern(this.backgroundFillImage, "repeat-x");
				ctx.fillRect(0, 0, width, height);
				if (this.value >= 1.0) {
					fillImage = this.completedFillImage;
				} else {
					fillImage = this.fillImage;
				}
			}

			if (! fillImage.complete)
				return;

			if (! this.indeterminate) {
				if (this.value < 0) {
					this.value = 0;
				} else if (this.value >= 1.0) {
					this.value = 1.0;
				}

				width = width * this.value;
			}

			this.phase = this.phase + 2;
			if (this.phase > fillImage.width)
				this.phase = 0;

			ctx.save();

			ctx.beginPath();
			ctx.rect(0, 0, width, height);
			ctx.closePath();
			ctx.clip();
				
			var offsetX = -fillImage.width + this.phase;

			while (offsetX < width) {
				ctx.drawImage(fillImage, offsetX, 0);
				offsetX += fillImage.width;
			}

			ctx.restore();
		}
	}
	
	OGRegisterForProgressBarAnimation(this);
	this.registeredForAnimation = true;

	return this;
}

var gProgressBars = new Array();

function OGRegisterForProgressBarAnimation(progressBar) {
 	var found = false;

	for (var i in gProgressBars) {
		if (gProgressBars[i] == progressBar) {
			found = true;
			break;
		}
	}
	
	if (! found) {
		gProgressBars.push(progressBar);
	}	
	
	if (gProgressBars.length > 0) {
		setTimeout("OGProgressBarAnimate()", 50);
	}
}

function OGUnregisterForProgressBarAnimation(progressBar) {
	var index = -1;
	for (var i in gProgressBars) {
		if (gProgressBars[i] == progressBar) {
			index = i;
			break;
		}
	}
	
	if (index != -1) {
		gProgressBars.splice(index, 1);
	}	
}

function OGProgressBarAnimate() {
	for (var i in gProgressBars) {
		var bar = gProgressBars[i];
		bar.draw();
	}

	if (gProgressBars.length > 0) {
		setTimeout("OGProgressBarAnimate()", 50);
	}
}

